// Craig S. Kaplan
//
// Draw a circle fractal like the one in Learning Processing, 
// Page 256.  Unlike the version in the textbook, keep track of
// an explicit number of recursive levels we'd like to draw, 
// which is simpler than basing the base case on a minimum
// radius.

void drawCircles( float x, float y, float r, int levels )
{
  // Draw a circle at the current size.
  ellipse( x, y, 2 * r, 2 * r );
  
  if( levels > 0 ) {
    // Still want to do recursion, so make two calls
    // at the next recursive level closer to the base case.
    drawCircles( x - r, y, r / 2, levels - 1 );
    drawCircles( x + r, y, r / 2, levels - 1 );
  }
}

void setup()
{
  size( 850, 500 );
  background( 255 );
  noFill();
  stroke( 0 );
  
  // Get the recursion started with one top-level call.
  drawCircles( width/2, height/2, 200, 8 );
}