// Craig S. Kaplan
//
// Another variation on the circle fractal example.  Just
// for fun, experiment with mapping the mouse position to
// variables controlling the scale ratio and rotation.  Try
// moving the mouse around the sketch window.  See the
// CircleFractalGeometricContext sketch for additional details
// on how this sketch works (apart from the scaling and rotation).

int levels = 8;
float fac = 0.5;
float theta = 0.0;

void setup()
{
  size( 1000, 600 );
}

void drawCircles( int levels )
{
  ellipse( 0, 0, 500, 500 );

  if ( levels > 0 ) {
    pushMatrix();
    translate( -250, 0 );
    rotate( -theta );
    scale( fac );
    drawCircles( levels - 1 );
    popMatrix();

    pushMatrix();
    rotate( PI );
    translate( -250, 0 );
    rotate( theta );
    scale( fac );
    drawCircles( levels - 1 );
    popMatrix();
  }
}

void draw()
{
  theta = map( mouseX, 0, width, 0, radians( 45 ) );
  fac = map( mouseY, 0, height, 0.1, 1.0 );
  
  background( 150 );
  stroke( 0 );
  strokeWeight( 5 );
  fill( 255, 60 );

  pushMatrix();
  translate( width/2, height/2 );
  drawCircles( levels );
  popMatrix();
}