// Craig S. Kaplan
// 
// A demonstration of non-recursive and recursive
// versions of the factorial function.

// A non-recursive factorial, which uses a for loop
// to multiply a bunch of numbers together.
int factorial_loop( int n )
{
  int total = 1;
  
  for( int idx = 1; idx <= n; ++idx ) {
    total = total * idx;
  }
  
  return total;
}

// A recursive factorial, which expresses the value
// of n! in terms of (n-1)!.
int factorial_recursive( int n )
{
  if( n == 1 ) {
    return 1;
  } else {
    return n * factorial_recursive( n - 1 );
  }
}

// A quick test to make sure you get the same values
// for both versions of the function.
void setup()
{
  for( int idx = 1; idx < 10; ++idx ) {
    println( "" + idx 
      + ": " + factorial_loop( idx ) 
      + ", " + factorial_recursive( idx ) );
  }
}