// Craig S. Kaplan
//
// A very simple demonstration of recursion, used here
// to draw a row of circles.  This is an attempt to express
// a direct translation into code of the first recursive 
// example shown in class for the website recursivedrawing.com.

// A recursive function.  We know it's recursive because 
// the body of the function contains a call to the same
// functin.
void myDrawing( int levels )
{
  ellipse( 50, 50, 100, 100 );
  
  // The test "levels > 0" is used to determine if we'd like
  // to do recursion.  We need some way *not* to do recursion,
  // in order to stop ourselves from going on forever.
  if ( levels > 0 ) {
    pushMatrix();
    translate( 105, 0 );
    // If we are making a recursive call, do it here, and 
    // make sure that the parameter passed in to the recursive
    // call makes progress towards the base case.
    myDrawing( levels - 1 );
    popMatrix();
  }
}

void setup()
{
  size( 730, 100 );
  background( 100 );
  myDrawing( 6 );
}